<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.room_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/community/room";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "房间名称",
              prop: "name",
              rules: [{
                required: true,
                message: "请输入房间名称",
                trigger: "blur"
              }]
            },
            {
              label: "社区id",
              prop: "agencyId",
              rules: [{
                required: true,
                message: "请输入社区id",
                trigger: "blur"
              }]
            },
            {
              label: "社区名称",
              prop: "agencyName",
              rules: [{
                required: true,
                message: "请输入社区名称",
                trigger: "blur"
              }]
            },
            {
              label: "小区id",
              prop: "residentialId",
              rules: [{
                required: true,
                message: "请输入小区id",
                trigger: "blur"
              }]
            },
            {
              label: "小区名称",
              prop: "residentialName",
              rules: [{
                required: true,
                message: "请输入小区名称",
                trigger: "blur"
              }]
            },
            {
              label: "楼栋id",
              prop: "buildingId",
              rules: [{
                required: true,
                message: "请输入楼栋id",
                trigger: "blur"
              }]
            },
            {
              label: "楼栋名称",
              prop: "buildingName",
              rules: [{
                required: true,
                message: "请输入楼栋名称",
                trigger: "blur"
              }]
            },
            {
              label: "单元id",
              prop: "unitId",
              rules: [{
                required: true,
                message: "请输入单元id",
                trigger: "blur"
              }]
            },
            {
              label: "单元名称",
              prop: "unitName",
              rules: [{
                required: true,
                message: "请输入单元名称",
                trigger: "blur"
              }]
            },
            {
              label: "楼层id",
              prop: "floorId",
              rules: [{
                required: true,
                message: "请输入楼层id",
                trigger: "blur"
              }]
            },
            {
              label: "楼层名称",
              prop: "floorName",
              rules: [{
                required: true,
                message: "请输入楼层名称",
                trigger: "blur"
              }]
            },
            {
              label: "房屋面积m2",
              prop: "area",
              rules: [{
                required: true,
                message: "请输入房屋面积m2",
                trigger: "blur"
              }]
            },
            {
              label: "户型",
              prop: "houseType",
              rules: [{
                required: true,
                message: "请输入户型",
                trigger: "blur"
              }]
            },
            {
              label: "房屋朝向",
              prop: "orientation",
              rules: [{
                required: true,
                message: "请输入房屋朝向",
                trigger: "blur"
              }]
            },
            {
              label: "住户数",
              prop: "userCount",
              rules: [{
                required: true,
                message: "请输入住户数",
                trigger: "blur"
              }]
            },
            {
              label: "备注",
              prop: "remark",
              rules: [{
                required: true,
                message: "请输入备注",
                trigger: "blur"
              }]
            },
            {
              label: "旧平台id",
              prop: "oldId",
              rules: [{
                required: true,
                message: "请输入旧平台id",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.room_add, false),
          viewBtn: this.vaildData(this.permission.room_view, false),
          delBtn: this.vaildData(this.permission.room_delete, false),
          editBtn: this.vaildData(this.permission.room_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
